<?php
/*
 * Plugin Name: Facebook Like
 * Author: Arun S. Sekhar [Physioblast, Arun]
 * Author URI: http://www.e107themes.net/
 * Requirement: e107 v0.7.xx
 *
 * Copyright (C) 2010 Arun S. Sekhar (http://www.e107themes.net)
 * Released under the terms and conditions of the
 * GNU General Public License (http://www.gnu.org/licenses/gpl.txt)
 *
 * File: update-check.php
 * 
 * $Rev: 21 $
 * $Date: 2010-07-31 14:08:44 +0400 (Sat, 31 Jul 2010) $
 * $Author: arunshekher $
 *
*/
if (!defined('e107_INIT')) { exit; }
require_once('../../class2.php');
if (!getperms('P')) {
header('location:'.e_HTTP.'index.php');
exit;
}
require_once(e_ADMIN.'auth.php');

/**
* Tried to add this in e_status.php which would've been a great option to show up plugin updates in admin homepage.
* But it seems like e107 doesn't like db calls from e_status.php, hence one need to come to the plugin config page to know about updates.
*/
function check_Updates(){
	global $pref;	
	$url = 'http://sourceforge.net/api/file/index/project-id/336694/mtime/desc/rss';	
	if($url){
		$xml = @simplexml_load_file($url);		
	}
	if(!$xml){
		$notice = '<span id="update-err"><img src="'.e_PLUGIN.'facebook_like/images/error.png" alt="" />'.FBLK_PLUGIN_ALAN_79.'</span>';		
	}else{	
		$title = $xml->channel->item->title;	/* $title = /facebooklike_0.x.zip */
		$dl_link = $xml->channel->item->link;
		$frag = explode('_', $title);
		$version = substr($frag[1], 0, -4);
	}
	
	/* plug_installed = current version */
	$current_version = $pref['plug_installed']['facebook_like'];
	if($version){
		$connection = true;
	if($version > $current_version){		
		$notice = '<span id="update-yes">'.FBLK_PLUGIN_ALAN_80.' <a href="'.urldecode($dl_link).'" onclick="window.open(this.href,\'_blank\');return false;"><strong>'.FBLK_PLUGIN_ALAN_81.$version.'</strong><img src="'.e_PLUGIN.'facebook_like/images/arrow-down.png" alt="" /></a></span>';
		$update_available = 1;
		}
	else{
		$notice = '<span id="update-no"><img src="'.e_PLUGIN.'facebook_like/images/tick-small.png" alt="" />'.FBLK_PLUGIN_ALAN_82.$current_version.'</span>';
		$update_available = 0;
		}
	}

if($connection){		
	/* update check time to db */
	$time_now = time();
	if(!is_object($sql)){ $sql = new db; }
	$update_check = $sql->db_Update("generic", "gen_datestamp = '".$time_now."', gen_user_id = '".$update_available."', gen_ip = '".$version."', gen_chardata = '".$dl_link."' WHERE gen_type = 'facebooklike_update_check'");
	if(!$update_check){	
		$sql->db_Insert("generic", "'', 'facebooklike_update_check', '".$time_now."', '".$update_available."', '".$version."', '', '".$dl_link."'");
		}
	}
	return $notice;
}
	
/* get update info conditionally */
function get_updateInfo() {
global $pref;
if(!is_object($sql)){ $sql = new db; }
$sql->db_Select("generic","gen_datestamp, gen_user_id, gen_ip, gen_chardata", "gen_type = 'facebooklike_update_check'");
$update_info = $sql->db_Fetch();

$current_time = time();
$last_checked = $update_info['gen_datestamp'];
$current_version = $pref['plug_installed']['facebook_like'];
$latest_version = trim($update_info['gen_ip']);
$dl_link = trim($update_info['gen_chardata']);

if($current_version == $latest_version && $update_info['gen_user_id']){
	if(!is_object($sql)){ $sql = new db; }
	$sql->db_Update("generic", "gen_user_id = '0' WHERE gen_type = 'facebooklike_update_check'");
	}
	
if($current_time - $last_checked >= 86400){
	$text = check_Updates();	
}
else {
	if($update_info['gen_user_id']){
		$text = '<span id="update-yes">'.FBLK_PLUGIN_ALAN_80.' <a href="'.urldecode($dl_link).'" onclick="window.open(this.href,\'_blank\');return false;"><strong>'.FBLK_PLUGIN_ALAN_81.$latest_version.'</strong><img src="'.e_PLUGIN.'facebook_like/images/arrow-down.png" alt="" /></a></span>';
		}
	else{
		$text = '<span id="update-no"><img src="'.e_PLUGIN.'facebook_like/images/tick-small.png" alt="" />'.FBLK_PLUGIN_ALAN_82.$current_version.'</span>';
		}
	}
 return $text;
}

?>